diff --git a/tests/generic/012 b/tests/generic/012
index 6b1e20b..f87ca9b 100755
--- a/tests/generic/012
+++ b/tests/generic/012
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/016 b/tests/generic/016
index b994775..267ce4a 100755
--- a/tests/generic/016
+++ b/tests/generic/016
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/021 b/tests/generic/021
index 4729400..5c115e3 100755
--- a/tests/generic/021
+++ b/tests/generic/021
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/022 b/tests/generic/022
index 1228e51..83f2913 100755
--- a/tests/generic/022
+++ b/tests/generic/022
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/058 b/tests/generic/058
index 4a39a05..2e6c7bc 100755
--- a/tests/generic/058
+++ b/tests/generic/058
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/060 b/tests/generic/060
index 4493ba2..4a0b6d1 100755
--- a/tests/generic/060
+++ b/tests/generic/060
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/061 b/tests/generic/061
index f5e5076..8e6630d 100755
--- a/tests/generic/061
+++ b/tests/generic/061
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/063 b/tests/generic/063
index 9b72f69..b3c4ab6 100755
--- a/tests/generic/063
+++ b/tests/generic/063
@@ -36,7 +36,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 trap "_cleanup ; exit \$status" 0 1 2 3 15
diff --git a/tests/generic/310 b/tests/generic/310
index 895481c..550272d 100755
--- a/tests/generic/310
+++ b/tests/generic/310
@@ -46,7 +46,7 @@ status=1	# failure is the default!
 
 _cleanup()
 {
-	rm -rf $TEST_DIR/tmp
+	rm -rf $TEST_DIR/tmp $SEQ_DIR
 }
 trap "_cleanup; exit \$status" 0 1 2 3 15
 
diff --git a/tests/generic/314 b/tests/generic/314
index 49b03e4..4d4dd5f 100755
--- a/tests/generic/314
+++ b/tests/generic/314
@@ -34,6 +34,7 @@ _cleanup()
 {
     cd /
     rm -f $tmp.*
+    rm -rf $TEST_DIR/$seq-dir
 }
 
 # get standard environment, filters and checks
diff --git a/tests/generic/316 b/tests/generic/316
index 0ccf01f..74cec26 100755
--- a/tests/generic/316
+++ b/tests/generic/316
@@ -33,7 +33,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 _cleanup()
 {
     cd /
-    rm -f $tmp.*
+    rm -f $tmp.* $testfile
 }
 
 # get standard environment, filters and checks
diff --git a/tests/generic/355 b/tests/generic/355
index 97e2320..1c1a112 100755
--- a/tests/generic/355
+++ b/tests/generic/355
@@ -33,7 +33,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 _cleanup()
 {
 	cd /
-	rm -f $tmp.*
+	rm -f $tmp.* $testfile
 }
 
 # get standard environment, filters and checks
diff --git a/tests/generic/360 b/tests/generic/360
index 86e554b..8f76985 100755
--- a/tests/generic/360
+++ b/tests/generic/360
@@ -33,7 +33,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 _cleanup()
 {
 	cd /
-	rm -f $tmp.*
+	rm -f $tmp.* $linkfile
 }
 
 # get standard environment, filters and checks
diff --git a/tests/generic/394 b/tests/generic/394
index ae9a7b4..2b1a32b 100755
--- a/tests/generic/394
+++ b/tests/generic/394
@@ -35,6 +35,7 @@ _cleanup()
 	cd /
 	ulimit -f unlimited
 	rm -f $tmp.*
+	rm -f $TEST_DIR/$seq.$$*
 }
 
 # get standard environment, filters and checks
diff --git a/tests/overlay/007 b/tests/overlay/007
index ccf2b75..ed7914b 100755
--- a/tests/overlay/007
+++ b/tests/overlay/007
@@ -37,6 +37,7 @@ _cleanup()
 {
 	cd /
 	rm -f $tmp.*
+	rm -rf $TEST_DIR/$seq
 }
 
 # get standard environment, filters and checks
diff --git a/tests/xfs/077 b/tests/xfs/077
index eba4f08..17af5dd 100755
--- a/tests/xfs/077
+++ b/tests/xfs/077
@@ -39,7 +39,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 _cleanup()
 {
 	cd /
-	rm -f $tmp.*
+	rm -f $tmp.* $IMGFILE
 }
 
 # get standard environment, filters and checks
diff --git a/tests/xfs/078 b/tests/xfs/078
index 0d6eb55..f7b9cc8 100755
--- a/tests/xfs/078
+++ b/tests/xfs/078
@@ -38,6 +38,7 @@ _cleanup()
     rm -f $tmp.*
     umount $LOOP_MNT 2>/dev/null
     [ -n "$LOOP_DEV" ] && losetup -d $LOOP_DEV
+    rm -f $LOOP_IMG
     rmdir $LOOP_MNT
 }
 
diff --git a/tests/xfs/191-input-validation b/tests/xfs/191-input-validation
index cff3efa..d302c0e 100755
--- a/tests/xfs/191-input-validation
+++ b/tests/xfs/191-input-validation
@@ -35,7 +35,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 _cleanup()
 {
 	cd /
-	rm -f $tmp.*
+	rm -f $tmp.* $fsimg
 }
 
 # get standard environment, filters and checks